# -*- coding: utf-8 -*-

from odoo import api, fields, models, _


class ProductPublicCategory(models.Model):

    _inherit = "product.public.category"

    url_key = fields.Char(string="URL Key")

    @api.model
    def create(self, vals):
        res = super(ProductPublicCategory, self).create(vals)
        if res.url_key in ['', False, None]:
            self.env['website.rewrite'].setSeoUrlKey('pattern_category', res)
        return res

    def write(self, vals):
        for catObj in self:
            vals = self.env['website.rewrite'].createRedirectForRewrite(vals, catObj, 'product.public.category', 'pattern_category')
        res = super(ProductPublicCategory, self).write(vals)
        return res

    def update_seo_url(self):
        categoryIds = self._context.get('active_ids')
        categoryObjs = self.search([('id', 'in', categoryIds)])
        self.env['website.rewrite'].setSeoUrlKey('pattern_category', categoryObjs)
        text = "SEO Url key of {} category(s) have been successfully updated.".format(len(categoryObjs))
        # return self.env['wk.wizard.message'].genrated_message(text)

        return self.env['sh.message.wizard'].genrated_message(text)
