# -*- coding: utf-8 -*-

from odoo import api, fields, models, _


class WebsiteSeoRewriteSettings(models.TransientModel):
    _inherit = 'res.config.settings'
    _name = 'website.seo.rewrite.settings'
    _description = "website seo rewrite settings"

    use_suffix = fields.Boolean(string="Enable URL Suffix", related="website_id.use_suffix", readonly=False)
    suffix_product = fields.Char(string="Product URL Suffix", related="website_id.suffix_product", readonly=False)
    suffix_category = fields.Char(string="Category URL Suffix", related="website_id.suffix_category", readonly=False)
    pattern_product = fields.Char(string="Product URL Pattern", related="website_id.pattern_product", readonly=False)
    pattern_category = fields.Char(string="Category URL Pattern", related="website_id.pattern_category", readonly=False)
    use_category_url = fields.Boolean(string="Enable Category Hierarchy with Product URL",
                                      help="""Enable to append category along with product URL in Website""",
                                      related="website_id.use_category_url", readonly=False)
    use_category_hierarchy = fields.Boolean(string="Enable Category Hierarchy with Category URL",
                                            help="""Enable to manage category hierarchy option in Website""",
                                            related="website_id.use_category_hierarchy", readonly=False)
    use_server_rewrites = fields.Boolean(
        string="Enable Web Server Rewrites",
        help="""
            By enabling this feature page key will remove from url
            For Example :
            '/shop/product/catalog-product' => '/catalog-product'
            '/blog/my-blog/post/my-blog-first-post' => '/my-blog-first-post'
            """,
        related="website_id.use_server_rewrites", readonly=False
    )
    manual_redirects_ids = fields.One2many(comodel_name='manual.redirect',related='website_id.manual_redirects_ids',readonly=False)
    manual_redirect = fields.Char('Manual Redirect',related='website_id.manual_redirect', readonly=False)



